%
% Chiffrieren eines Textes mit einer linearen Blockchiffre
% der Lnge 2 ber Z/29.
%

function[C]=encrypt(T)

global a b c d;
global Tabelle;
global Klartext;
global Chiffretext;

if isempty(T)==1
    disp('Kein Text vorhanden.');
    return;
end

% Textlnge ggf. durch 2 teilbar machen
% (Blank anfgen)

LT=length(T);

if mod(LT,2)==1
    T=[T ' '];
    LT=length(T);
end

Klartext=T;

% Alphabetwechsel nach Z/29

S=[];

for k=1:1:LT
    idx=find(Tabelle==T(k));
    if isempty(idx)==1
        disp('Unzulssiges Zeichen im Text.');
        return;
    end
    S=[S;idx-1];
end

disp(' ');
disp('Text nach Alphabetwechsel zu Z/29:');
NS=createstr(S);
disp(NS);
disp(' ');

% Chiffrieren

E=[a b;c d];
C=[];

for k=1:2:LT-1
    C=[C;mod(E*S(k:k+1),29)];
end

CT=[];

for k=1:1:LT
    CT=[CT Tabelle(C(k)+1)];
end

Chiffretext=CT;

disp('Chiffrierter Text in Z/29: ');
NS=createstr(C);
disp(NS);
disp(' ');
disp('Chiffrierter Text: ');
disp(CT);

return;